2024-07-08 23:07:06 +03:00
# shellcheck shell=bash
2024-05-06 16:42:49 +03:00
2021-12-09 17:26:46 +02:00
set -eu -o pipefail
2006-03-01 14:15:33 +02:00
2024-07-08 23:07:06 +03:00
if [ [ -z " ${ COMMON_FUNCTIONS_SH_SOURCED - } " ] ] ; then
2021-07-26 07:54:55 +03:00
2024-07-08 23:07:06 +03:00
COMMON_FUNCTIONS_SH_SOURCED = 1
2021-07-26 07:54:55 +03:00
2024-06-16 13:13:07 +03:00
isTestOnNixOS( ) {
[ [ " ${ isTestOnNixOS :- } " = = 1 ] ]
}
die( ) {
2024-06-24 19:11:10 +03:00
echo " unexpected fatal error: $* " >& 2
2024-06-16 13:13:07 +03:00
exit 1
}
2006-03-01 16:26:03 +02:00
readLink( ) {
2024-07-08 23:07:06 +03:00
# TODO fix this
# shellcheck disable=SC2012
2006-03-01 16:26:03 +02:00
ls -l " $1 " | sed 's/.*->\ //'
}
2006-09-21 21:54:08 +03:00
2009-03-18 18:35:35 +02:00
clearProfiles( ) {
2024-07-08 23:07:06 +03:00
profiles = " $HOME /.local/state/nix/profiles "
2021-11-17 22:35:21 +02:00
rm -rf " $profiles "
2009-03-18 18:35:35 +02:00
}
2024-06-16 18:56:50 +03:00
# Clear the store, but do not fail if we're in an environment where we can't.
# This allows the test to run in a NixOS test environment, where we use the system store.
# See doc/manual/src/contributing/testing.md / Running functional tests on NixOS.
clearStoreIfPossible( ) {
if isTestOnNixOS; then
echo "clearStoreIfPossible: Not clearing store, because we're on NixOS. Moving on."
else
doClearStore
fi
}
2006-09-21 21:54:08 +03:00
clearStore( ) {
2024-06-16 13:13:07 +03:00
if isTestOnNixOS; then
2024-06-16 18:56:50 +03:00
die "clearStore: not supported when testing on NixOS. If not essential, call clearStoreIfPossible. If really needed, add conditionals; e.g. if ! isTestOnNixOS; then ..."
2024-06-16 13:13:07 +03:00
fi
2024-06-16 18:56:50 +03:00
doClearStore
}
2024-06-16 13:13:07 +03:00
2024-06-16 18:56:50 +03:00
doClearStore( ) {
2006-09-21 21:54:08 +03:00
echo "clearing store..."
chmod -R +w " $NIX_STORE_DIR "
rm -rf " $NIX_STORE_DIR "
mkdir " $NIX_STORE_DIR "
2016-07-27 18:14:41 +03:00
rm -rf " $NIX_STATE_DIR "
mkdir " $NIX_STATE_DIR "
2009-03-18 18:35:35 +02:00
clearProfiles
2006-09-21 21:54:08 +03:00
}
2007-08-13 16:15:02 +03:00
2014-02-17 13:22:50 +02:00
clearCache( ) {
2024-07-08 23:07:06 +03:00
rm -rf " ${ cacheDir ? } "
2014-02-17 13:22:50 +02:00
}
2016-05-30 21:22:30 +03:00
clearCacheCache( ) {
2024-07-08 23:07:06 +03:00
rm -f " $TEST_HOME /.cache/nix/binary-cache " *
2016-05-30 21:22:30 +03:00
}
2011-07-20 14:50:13 +03:00
startDaemon( ) {
2024-06-16 13:13:07 +03:00
if isTestOnNixOS; then
die "startDaemon: not supported when testing on NixOS. Is it really needed? If so add conditionals; e.g. if ! isTestOnNixOS; then ..."
fi
2021-07-26 07:54:55 +03:00
# Don’ t start the daemon twice, as this would just make it loop indefinitely
2021-12-09 17:16:18 +02:00
if [ [ " ${ _NIX_TEST_DAEMON_PID - } " != '' ] ] ; then
return
2021-07-26 07:54:55 +03:00
fi
2022-03-02 23:22:55 +02:00
# Start the daemon, wait for the socket to appear.
2024-07-08 23:07:06 +03:00
rm -f " $NIX_DAEMON_SOCKET_PATH "
2023-12-18 20:36:18 +02:00
PATH = $DAEMON_PATH nix --extra-experimental-features 'nix-command' daemon &
2021-12-09 17:16:18 +02:00
_NIX_TEST_DAEMON_PID = $!
export _NIX_TEST_DAEMON_PID
2022-02-24 15:57:27 +02:00
for ( ( i = 0; i < 300; i++) ) ; do
2022-02-28 15:41:09 +02:00
if [ [ -S $NIX_DAEMON_SOCKET_PATH ] ] ; then
DAEMON_STARTED = 1
break;
fi
2022-02-24 15:57:27 +02:00
sleep 0.1
2011-10-11 14:14:30 +03:00
done
2022-02-28 15:41:09 +02:00
if [ [ -z ${ DAEMON_STARTED +x } ] ] ; then
fail "Didn’ t manage to start the daemon"
fi
2021-07-26 07:54:55 +03:00
trap "killDaemon" EXIT
2021-12-09 17:16:18 +02:00
# Save for if daemon is killed
NIX_REMOTE_OLD = $NIX_REMOTE
2011-07-20 14:50:13 +03:00
export NIX_REMOTE = daemon
}
killDaemon( ) {
2024-06-16 13:13:07 +03:00
if isTestOnNixOS; then
die "killDaemon: not supported when testing on NixOS. Is it really needed? If so add conditionals; e.g. if ! isTestOnNixOS; then ..."
fi
2021-12-09 17:16:18 +02:00
# Don’ t fail trying to stop a non-existant daemon twice
if [ [ " ${ _NIX_TEST_DAEMON_PID - } " = = '' ] ] ; then
return
fi
2024-07-08 23:07:06 +03:00
kill " $_NIX_TEST_DAEMON_PID "
2022-02-24 15:57:27 +02:00
for i in { 0..100} ; do
2024-07-08 23:07:06 +03:00
kill -0 " $_NIX_TEST_DAEMON_PID " 2> /dev/null || break
2022-02-24 15:57:27 +02:00
sleep 0.1
2021-07-26 07:54:55 +03:00
done
2024-07-08 23:07:06 +03:00
kill -9 " $_NIX_TEST_DAEMON_PID " 2> /dev/null || true
wait " $_NIX_TEST_DAEMON_PID " || true
rm -f " $NIX_DAEMON_SOCKET_PATH "
2021-12-09 17:16:18 +02:00
# Indicate daemon is stopped
unset _NIX_TEST_DAEMON_PID
# Restore old nix remote
NIX_REMOTE = $NIX_REMOTE_OLD
2011-07-20 14:50:13 +03:00
trap "" EXIT
}
2021-07-26 07:54:55 +03:00
restartDaemon( ) {
2024-06-16 13:13:07 +03:00
if isTestOnNixOS; then
die "restartDaemon: not supported when testing on NixOS. Is it really needed? If so add conditionals; e.g. if ! isTestOnNixOS; then ..."
fi
2021-12-09 17:16:18 +02:00
[ [ -z " ${ _NIX_TEST_DAEMON_PID :- } " ] ] && return 0
2021-07-26 07:54:55 +03:00
2022-07-14 16:06:11 +03:00
killDaemon
startDaemon
2021-07-26 07:54:55 +03:00
}
isDaemonNewer ( ) {
[ [ -n " ${ NIX_DAEMON_PACKAGE :- } " ] ] || return 0
local requiredVersion = " $1 "
2024-07-08 23:07:06 +03:00
local daemonVersion
daemonVersion = $( " $NIX_DAEMON_PACKAGE /bin/nix " daemon --version | cut -d' ' -f3)
2021-10-14 16:42:54 +03:00
[ [ $( nix eval --expr " builtins.compareVersions '' $daemonVersion '' '' $requiredVersion '' " ) -ge 0 ] ]
2021-07-26 07:54:55 +03:00
}
2023-03-16 22:00:20 +02:00
skipTest ( ) {
echo " $1 , skipping this test... " >& 2
2024-07-25 05:36:43 +03:00
exit 77
2023-03-16 22:00:20 +02:00
}
2024-06-16 13:13:07 +03:00
TODO_NixOS( ) {
if isTestOnNixOS; then
skipTest "This test has not been adapted for NixOS yet"
fi
}
2021-07-26 07:54:55 +03:00
requireDaemonNewerThan ( ) {
2023-03-16 22:00:20 +02:00
isDaemonNewer " $1 " || skipTest "Daemon is too old"
2021-07-26 07:54:55 +03:00
}
2018-11-07 18:08:28 +02:00
canUseSandbox( ) {
2023-03-16 22:00:20 +02:00
[ [ ${ _canUseSandbox - } ] ]
}
2018-01-13 15:18:35 +02:00
2023-03-16 22:00:20 +02:00
requireSandboxSupport ( ) {
canUseSandbox || skipTest "Sandboxing not supported"
}
requireGit( ) {
[ [ $( type -p git) ] ] || skipTest "Git not installed"
2018-01-13 15:18:35 +02:00
}
2009-03-17 19:38:32 +02:00
fail( ) {
2024-06-24 19:11:58 +03:00
echo " test failed: $* " >& 2
2009-03-17 19:38:32 +02:00
exit 1
}
2012-07-27 21:33:01 +03:00
2021-12-09 17:26:46 +02:00
# Run a command failing if it didn't exit with the expected exit code.
#
# Has two advantages over the built-in `!`:
#
# 1. `!` conflates all non-0 codes. `expect` allows testing for an exact
# code.
#
# 2. `!` unexpectedly negates `set -e`, and cannot be used on individual
# pipeline stages with `set -o pipefail`. It only works on the entire
# pipeline, which is useless if we want, say, `nix ...` invocation to
# *fail*, but a grep on the error message it outputs to *succeed*.
2017-11-15 13:23:31 +02:00
expect( ) {
local expected res
expected = " $1 "
shift
2021-12-09 17:26:46 +02:00
" $@ " && res = 0 || res = " $? "
2024-07-16 02:28:28 +03:00
# also match "negative" codes, which wrap around to >127
2024-07-08 23:07:06 +03:00
if [ [ $res -ne $expected && $res -ne $(( 256 + expected)) ] ] ; then
2023-07-07 16:08:25 +03:00
echo " Expected exit code ' $expected ' but got ' $res ' from command ${ *@Q } " >& 2
2021-12-09 17:26:46 +02:00
return 1
fi
return 0
}
# Better than just doing `expect ... >&2` because the "Expected..."
# message below will *not* be redirected.
expectStderr( ) {
local expected res
expected = " $1 "
shift
" $@ " 2>& 1 && res = 0 || res = " $? "
2024-07-16 02:28:28 +03:00
# also match "negative" codes, which wrap around to >127
2024-07-08 23:07:06 +03:00
if [ [ $res -ne $expected && $res -ne $(( 256 + expected)) ] ] ; then
2023-07-07 16:08:25 +03:00
echo " Expected exit code ' $expected ' but got ' $res ' from command ${ *@Q } " >& 2
2022-05-02 16:12:50 +03:00
return 1
fi
return 0
2017-11-15 13:23:31 +02:00
}
2024-02-29 00:35:10 +02:00
# Run a command and check whether the stderr matches stdin.
# Show a diff when output does not match.
# Usage:
#
# assertStderr nix profile remove nothing << EOF
# error: This error is expected
# EOF
assertStderr( ) {
2024-07-08 23:07:06 +03:00
diff -u /dev/stdin <( " $@ " 2>/dev/null 2>& 1)
2024-02-29 00:35:10 +02:00
}
2021-07-26 07:54:55 +03:00
needLocalStore( ) {
if [ [ " $NIX_REMOTE " = = "daemon" ] ] ; then
2023-03-16 22:00:20 +02:00
skipTest " Can’ t run through the daemon ( $1 ) "
2021-07-26 07:54:55 +03:00
fi
}
# Just to make it easy to find which tests should be fixed
2022-03-02 22:48:25 +02:00
buggyNeedLocalStore( ) {
2021-12-09 17:26:46 +02:00
needLocalStore " $1 "
2021-07-26 07:54:55 +03:00
}
2022-03-02 22:48:25 +02:00
enableFeatures( ) {
local features = " $1 "
2024-07-08 23:07:06 +03:00
sed -i 's/experimental-features .*/& ' " $features " '/' " ${ test_nix_conf ? } "
2022-03-02 22:48:25 +02:00
}
2022-07-14 16:06:11 +03:00
onError( ) {
set +x
echo " $0 : test failed at: " >& 2
2022-07-27 17:41:26 +03:00
for ( ( i = 1; i < ${# BASH_SOURCE [@] } ; i++) ) ; do
2022-07-14 16:06:11 +03:00
if [ [ -z ${ BASH_SOURCE [i] } ] ] ; then break; fi
echo " ${ FUNCNAME [i] } in ${ BASH_SOURCE [i] } : ${ BASH_LINENO [i-1] } " >& 2
done
}
2024-07-16 02:40:14 +03:00
# Prints an error message prefix referring to the last call into this file.
# Ignores `expect` and `expectStderr` calls.
# Set a special exit code when test suite functions are misused, so that
# functions like expectStderr won't mistake them for expected Nix CLI errors.
# Suggestion: -101 (negative to indicate very abnormal, and beyond the normal
# range of signals)
# Example (showns as string): 'repl.sh:123: in call to grepQuiet: '
# This function is inefficient, so it should only be used in error messages.
callerPrefix( ) {
2024-07-23 11:24:18 +03:00
# Find the closest caller that's not from this file
# using the bash `caller` builtin.
2024-07-16 02:40:14 +03:00
local i file line fn savedFn
# Use `caller`
for i in $( seq 0 100) ; do
2024-07-08 23:07:06 +03:00
caller " $i " > /dev/null || {
2024-07-16 02:40:14 +03:00
if [ [ -n " ${ file :- } " ] ] ; then
echo " $file : $line : ${ savedFn +in call to $savedFn : } "
fi
break
}
2024-07-08 23:07:06 +03:00
line = " $( caller " $i " | cut -d' ' -f1) "
fn = " $( caller " $i " | cut -d' ' -f2) "
file = " $( caller " $i " | cut -d' ' -f3) "
2024-07-16 02:40:14 +03:00
if [ [ $file != " ${ BASH_SOURCE [0] } " ] ] ; then
echo " $file : $line : ${ savedFn +in call to $savedFn : } "
return
fi
case " $fn " in
# Ignore higher order functions that don't report any misuse of themselves
# This way a misuse of a foo in `expectStderr 1 foo` will be reported as
# calling foo, not expectStderr.
expect| expectStderr| callerPrefix)
; ;
*)
savedFn = " $fn "
; ;
esac
done
}
2024-07-16 02:41:22 +03:00
checkGrepArgs( ) {
local arg
for arg in " $@ " ; do
if [ [ " $arg " != " ${ arg // $'\n' /_ } " ] ] ; then
echo " $( callerPrefix) newline not allowed in arguments; grep would try each line individually as if connected by an OR operator " >& 2
2024-07-08 23:07:06 +03:00
return 155 # = -101 mod 256
2024-07-16 02:41:22 +03:00
fi
done
}
2021-12-09 17:26:46 +02:00
# `grep -v` doesn't work well for exit codes. We want `!(exist line l. l
# matches)`. It gives us `exist line l. !(l matches)`.
#
# `!` normally doesn't work well with `set -e`, but when we wrap in a
# function it *does*.
2024-07-16 02:54:12 +03:00
#
# `command grep` lets us avoid re-checking the args by going directly to the
# executable.
2021-12-09 17:26:46 +02:00
grepInverse( ) {
2024-07-16 02:41:22 +03:00
checkGrepArgs " $@ " && \
2024-07-16 02:54:12 +03:00
! command grep " $@ "
2021-12-09 17:26:46 +02:00
}
# A shorthand, `> /dev/null` is a bit noisy.
#
# `grep -q` would seem to do this, no function necessary, but it is a
# bad fit with pipes and `set -o pipefail`: `-q` will exit after the
# first match, and then subsequent writes will result in broken pipes.
#
# Note that reproducing the above is a bit tricky as it depends on
# non-deterministic properties such as the timing between the match and
# the closing of the pipe, the buffering of the pipe, and the speed of
# the producer into the pipe. But rest assured we've seen it happen in
# CI reliably.
2024-07-16 02:54:12 +03:00
#
# `command grep` lets us avoid re-checking the args by going directly to the
# executable.
2021-12-09 17:26:46 +02:00
grepQuiet( ) {
2024-07-16 02:41:22 +03:00
checkGrepArgs " $@ " && \
2024-07-16 02:54:12 +03:00
command grep " $@ " > /dev/null
2021-12-09 17:26:46 +02:00
}
# The previous two, combined
grepQuietInverse( ) {
2024-07-16 02:41:22 +03:00
checkGrepArgs " $@ " && \
2024-07-16 02:54:12 +03:00
! command grep " $@ " > /dev/null
}
# Wrap grep to remove its newline footgun; see checkGrepArgs.
# Note that we keep the checkGrepArgs calls in the other helpers, because some
# of them are negated and that would defeat this check.
grep( ) {
checkGrepArgs " $@ " && \
command grep " $@ "
2021-12-09 17:26:46 +02:00
}
2024-03-24 16:04:06 +02:00
# Return the number of arguments
count( ) {
echo $#
}
2022-07-14 16:06:11 +03:00
trap onError ERR
2024-07-08 23:07:06 +03:00
fi # COMMON_FUNCTIONS_SH_SOURCED